/*

 Sample how to integrate C# UI for IDA plugin
 http://sandsprite.com/CodeStuff/VB_Plugin_for_Olly.html

*/

#include <windows.h>  //define this before other headers or get errors 
#include <ida.hpp>
#include <idp.hpp>
#include <expr.hpp>
#include <bytes.hpp>
#include <loader.hpp>
#include <kernwin.hpp>

// you have to generate this tlb file manually with 
// c:\> regasm [.net dllname] /tlb:[tlbpath]
#import "./bin_4.7/CSharpIDASample.tlb" raw_interfaces_only

using namespace CSharpIDASample;

ICPluginPtr pIPlug(__uuidof(CPlugin));

void StartPlugin(){
	long lRet=0;
	int h = (int)callui(ui_get_hwnd).vptr; //ida main window hwnd
	pIPlug->DoPluginAction( h , &lRet);
}

int  idaapi init(void)  {  HRESULT hr = CoInitialize(NULL); return PLUGIN_KEEP; }
void idaapi term(void)  {  pIPlug->Release(); delete pIPlug; CoUninitialize();  }
void idaapi run(int arg){  StartPlugin();                                       }

char comment[] = "This is a sample plugin. It does nothing useful";
char help[] ="A C# sample plugin module\n\nThis module shows you how to integrate C# with your plugin modules.\n\nIt does nothing useful - just enumerates all functions start and\nend addresses.\n";
char wanted_name[] = "C# Sample plugin";
char wanted_hotkey[] = "Alt-0";

//Plugin Descriptor Block
plugin_t PLUGIN =
{
  IDP_INTERFACE_VERSION,
  0,                    // plugin flags
  init,                 // initialize
  term,                 // terminate. this pointer may be NULL.
  run,                  // invoke plugin
  comment,              // long comment about the plugin (status line or hint)
  help,                 // multiline help about the plugin
  wanted_name,          // the preferred short name of the plugin
  wanted_hotkey         // the preferred hotkey to run the plugin
};











//Export API for the C# app to call and access IDA API data
//_________________________________________________________________
int __stdcall NumFuncs(void){
	return get_func_qty(); 
}

int __stdcall FunctionStart(int n){
	func_t *clsFx = getn_func(n);
	return clsFx->startEA;
}

int __stdcall FunctionEnd(int n){
	func_t *clsFx = getn_func(n);
	return clsFx->endEA;
}

/* 

###  untested with C# yet not sure on type conversions  ###

int __stdcall GetBytes(int offset, void *buf, int length){
	return get_many_bytes(offset, buf, length);
}

void __stdcall FuncName(int addr, char *buf, size_t bufsize){
		get_func_name(addr, buf, bufsize);
}

int __stdcall GetAsm(int addr, char* buf, int bufLen){

    flags_t flags;                                                       
    int sLen=0;

    flags = getFlags(addr);                        
    if(isCode(flags)) {                            
        generate_disasm_line(addr, buf, bufLen, GENDSM_MULTI_LINE );
        sLen = tag_remove(buf, buf, bufLen);  
    }

	return sLen;

}

*/

